//+--------------------------------------------------------------------------------------------+
//|   RenkoSR_v2.0.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_color4 Red

extern bool ShowMinorSR = true;

int i;
int ev = EMPTY_VALUE;
string Trend;
double CurrRes,PrevRes,CurrSup,PrevSup;

double MajorRes[];
double MinorRes[];
double MajorSup[];
double MinorSup[];

int init()
{
   IndicatorBuffers(4);

   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,MajorRes);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(1,MinorRes);
   
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexBuffer(2,MajorSup);
   
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(3,MinorSup);
   
   return(0);
}

int deinit()
{

   ObjectsDeleteAll();
   
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   
   for (i=Bars-counted_bars;i>=0;i--)
   {
      MajorRes[i] = MajorRes[i+1];
      MajorSup[i] = MajorSup[i+1];
      MinorRes[i] = MinorRes[i+1];
      MinorSup[i] = MinorSup[i+1];

      if (Close[i+3] > Open[i+3] && 
          Close[i+2] > Open[i+2] &&    
          Close[i+1] < Open[i+1])// major res
      {
         PrevRes = CurrRes;
         CurrRes = Close[i+2];
         if (CurrRes < ev && PrevRes < ev && CurrRes >= PrevRes)
         {
            MajorRes[i+2] = Close[i+2];
            MajorRes[i+1] = Close[i+2];
            MajorRes[i] = Close[i+2];
         }
      }
   
      if (Close[i+3] < Open[i+3] && 
          Close[i+2] < Open[i+2] && 
          Close[i+1] > Open[i+1])// major sup
      {
         PrevSup = CurrSup;
         CurrSup = Close[i+2];
         if (CurrSup < ev && PrevSup < ev && CurrSup <= PrevSup)
         {
            MajorSup[i+2] = Close[i+2];
            MajorSup[i+1] = Close[i+2];
            MajorSup[i] = Close[i+2];
         }
      }

      if (ShowMinorSR)
      {
         if (Close[i+3] > Open[i+3] && 
             Close[i+2] > Open[i+2] && 
             Close[i+1] < Open[i+1])// minor res
         {
               MinorRes[i+2] = Close[i+2];
               MinorRes[i+1] = Close[i+2];
               MinorRes[i] = Close[i+2];
         }
         else
         if (Close[i+3] < Open[i+3] && 
             Close[i+2] < Open[i+2] && 
             Close[i+1] > Open[i+1])// minor sup
         {
               MinorSup[i+2] = Close[i+2];
               MinorSup[i+1] = Close[i+2];
               MinorSup[i] = Close[i+2];
         }
      }

      if (MinorRes[i] > MajorRes[i] || MinorRes[i] < MajorSup[i] || Close[i+1] > MinorRes[i])
      {
         MinorRes[i] = ev;
      }
      
      if (MinorSup[i] > MajorRes[i] || MinorSup[i] < MajorSup[i] || Close[i+1] < MinorSup[i])
      {
         MinorSup[i] = ev;
      }
      
      DrawMajorRL();
      DrawMajorSL();
      
      DrawMinorRL();
      DrawMinorSL();
      
   }   

   Comment(" ");
//   Comment("\nPrev High = ",DoubleToStr(PrevHigh,Digits),"   Curr High = ",DoubleToStr(CurrHigh,Digits),
//           "\nPrev Low  = ",DoubleToStr(PrevLow,Digits),"   Curr Low  = ",DoubleToStr(CurrLow,Digits),
//           "\nCurrTrend = ",Trend);
}   
   
void DrawMajorRL()
{
      ObjectDelete("MajorRL");
      ObjectCreate("MajorRL",OBJ_TREND,0,0,0,0,0);
      ObjectSet("MajorRL",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("MajorRL",OBJPROP_PRICE1,MajorRes[i]);
      ObjectSet("MajorRL",OBJPROP_TIME2,Time[i]);
      ObjectSet("MajorRL",OBJPROP_PRICE2,MajorRes[i]);
      ObjectSet("MajorRL",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("MajorRL",OBJPROP_WIDTH,2);
      ObjectSet("MajorRL",OBJPROP_RAY,True);
      ObjectSet("MajorRL",OBJPROP_COLOR,Green);
}
   
void DrawMajorSL()
{
      ObjectDelete("MajorSL");
      ObjectCreate("MajorSL",OBJ_TREND,0,0,0,0,0);
      ObjectSet("MajorSL",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("MajorSL",OBJPROP_PRICE1,MajorSup[i]);
      ObjectSet("MajorSL",OBJPROP_TIME2,Time[i]);
      ObjectSet("MajorSL",OBJPROP_PRICE2,MajorSup[i]);
      ObjectSet("MajorSL",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("MajorSL",OBJPROP_WIDTH,2);
      ObjectSet("MajorSL",OBJPROP_RAY,True);
      ObjectSet("MajorSL",OBJPROP_COLOR,Red);
}

void DrawMinorRL()
{
      ObjectDelete("MinorRL");
      ObjectCreate("MinorRL",OBJ_TREND,0,0,0,0,0);
      ObjectSet("MinorRL",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("MinorRL",OBJPROP_PRICE1,MinorRes[i]);
      ObjectSet("MinorRL",OBJPROP_TIME2,Time[i]);
      ObjectSet("MinorRL",OBJPROP_PRICE2,MinorRes[i]);
      ObjectSet("MinorRL",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("MinorRL",OBJPROP_RAY,True);
      ObjectSet("MinorRL",OBJPROP_COLOR,Green);
}
   
void DrawMinorSL()
{
      ObjectDelete("MinorSL");
      ObjectCreate("MinorSL",OBJ_TREND,0,0,0,0,0);
      ObjectSet("MinorSL",OBJPROP_TIME1,Time[i+1]);
      ObjectSet("MinorSL",OBJPROP_PRICE1,MinorSup[i]);
      ObjectSet("MinorSL",OBJPROP_TIME2,Time[i]);
      ObjectSet("MinorSL",OBJPROP_PRICE2,MinorSup[i]);
      ObjectSet("MinorSL",OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("MinorSL",OBJPROP_RAY,True);
      ObjectSet("MinorSL",OBJPROP_COLOR,Red);
}

//+--------------------------------------------------------------------------------------------+